<!doctype html>
<html>

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

	<title>Introduction to Assembly</title>

	<link rel="icon" type="image/png" href="images/org_symbol.png" />
	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">
	<link rel="stylesheet" href="css/theme/league.css" id="theme">

	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName('head')[0].appendChild(link);
	</script>
</head>

<body>
	<!-- UGLY inline CSS but using this div to test Unclassified banner -->
	<!-- <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div> -->
	<div class="reveal">
		<div class="slides">
			<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">
				<section>
					<h1>Introduction to Assembly</h1>
					<h4>90th Cyberspace Operations Squadron</h4>
				</section>
				<section>
					<h2>Objectives</h2>
					<a href="../objectives.html" target="_blank">Introduction to ASM Operations Objectives</a>
				</section>
				<section>
					<h2>Summary</h2>
					<h3>Introduction to Assembly</h3>
					<ul>
						<li>Computer Basics Review</li>
						<li>ASM Basics</li>
						<li>ASM Data Types</li>
						<li>Advanced Assembly Data Types</li>
					</ul>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
						instructor view!!
					</aside>
				</section>

				<!-- FILL WITH SECTIONS (SLIDES) -->
				<section>
					<h2>Overview</h2>
					<ul>
						<li>What is ASM?</li>
						<li>Why would we use ASM?</li>
						<li>What are the ASM basic operands?</li>
						<li>What are the ASM basic data types?</li>
						<li>What are ASM advanced data types?</li>
						<li>Why / how / when are advanced data types used in ASM?</li>
					</ul>
				</section>
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<section>
					<h2>Computer Basics </h2>
					<ul>
						<li>bits vs bytes</li>
						<li>CPU vs RAM vd SDD</li>
					</ul>
				</section>

				<section>
					<h2>CPU Architectures</h2>
					<ul>
						<li>Intel x86(_64)</li>
						<li>Intel x86</li>
						<li>AMD x86(_64)</li>
						<li>AMD x86</li>
						<li>ARM</li>
						<li>PowerPC</li>
					</ul>
				</section>
				<section>
					<h2>What is a register?</h2>
					<h3>What is it good for?</h3>
				</section>
				<section>
					<h3>Fastest to slowest</h3>
					<ol>
						<li>Registers</li>
						<li>Cache (L1/L2/L3)</li>
						<li>System Memory (RAM)</li>
						<li>Disk (HDD/SDD/etc) </li>
					</ol>
				</section>

				<section>
					<h2>Process Memory Layout</h2>
					<img src="../../assets/process_mem.png" width="360">
				</section>

				<section>
					<h3>Big-endian vs Little-Endian</h3>
					<h4><em>byte</em> not bit</h4>
					<table>
						<tr>
							<td><em>Initial:</em></td>
							<td>0xde</td>
							<td>0xad</td>
							<td>0xbe</td>
							<td>0xef</td>
						</tr>
						<tr>
							<td>Little Endian</td>
						</tr>
						<tr>
							<td><em>Memory:</em></td>
							<td>0xef</td>
							<td>0xbe</td>
							<td>0xad</td>
							<td>0xde</td>
						</tr>
						<tr>
							<td>Big Endian</td>
						</tr>
						<tr>
							<td><em>Memory:</em></td>
							<td> 0xde</td>
							<td>0xad</td>
							<td>0xbe </td>
							<td> 0xef</td>
						</tr>
					</table>
					<p>See also <a href="https://www.gnu-pascal.de/gpc/Endianness.html">here</a></p>
				</section>
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<section>

					<h1><em>Understanding Registers is the key to Assembly </em></h1>


				</section>

				<section>

					<h2>The most fundamental registers</h2>
					<img src="../../assets/register_table.png" height="50%"">
					<p style=" font-size: 80%;">More information available at <a
						href="https://en.wikibooks.org/wiki/X86_Assembly/X86_Architecture">WikiBooks</a></p>

				</section>
				<section>

					<h2>The most fundamental registers</h2>
					<img src="../../assets/register_overlap.png" width="700">

				</section>

				<section>

					<h2>An extended list of registers</h2>
					<img src="../../assets/extended_register_table.png" height="50%"">
					<p style=" font-size: 80%;">More information available at <a
						href="https://en.wikibooks.org/wiki/X86_Assembly/X86_Architecture">WikiBooks</a></p>

				</section>
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">

				<section>
					<h2>ASM Basics </h2>


				</section>

				<section>
					<h2>opcodes vs operands</h2>
					<h3><em>opcode</em> - instruction</h3>
					<h3><em>operand</em> - data </h3>
				</section>

				<section>
					<h2>A few Assemmblers </h2>
					<h3>GAS</h3>
					<h3>NASM/YASM</h3>
					<h3>MASM</h3>
				</section>

				<section>
					<table>
						<tr>
							<td><em>Intel Syntax </em> </td>
							<td> </td>
							<td><em>AT&T Syntax </em> </td>
						</tr>
						<tr>
							<td>mov eax, 0x01</td>
							<td> </td>
							<td>movl $0x01, %eax</td>
						</tr>
					</table>
					<br>
					<p style="font-size: 70%">We will be using Intel syntax.</p>
				</section>

				<section>
					<p style="color: #c678dd;  font-size:220%; font-weight:bold">mov</p>
					<p style="color:#9d8c92;  font-size:120%; font-weight:bold">Copies to <em
							style="color: #c99464">d</em>e<em style="color: #c99464">st</em>ination from <em
							style="color: #c99464">s</em>ou<em style="color: #c99464">rc</em>e</p>
					<img src="../../assets/mov_example.png" height="200">

				</section>
				<section>
					<h2>We can copy data to registers</h2>
					<p style="font-size:220%; font-weight:bold">including <em>pointers</em> (memory
						addresses)</p>
				</section>
				<section>
					<p style="font-size:200%; font-weight:bold">We can directly manipulate address data</p>
					<p>with addition, subtraction, and more.</p>
					<p style="font-weight:bold"><em style="color:#c678dd;"">[ ]</em> (square brackets) dereference registers <br>i.e. access the data</p>
</section>
</section>
<section data-background-image=" images/org_symbol.png" data-background-size="13%"
							data-background-position="top 5% left 5%">
							<section>
								<p style="font-size:200%; font-weight:bold">mov</p>
								<p style="font-size:200%; font-weight:bold">the copy command</p>
							</section>

							<section>
								<p style="font-size:200%; font-weight:bold"><em>mov</em> to pointer example</p>
								<table>
									<tr>
										<td><img src=" ../../assets/mov_pointer1.png"> </td>
										<td><img src="../../assets/dereference.png"></td>
									</tr>
								</table>
							</section>

							<section>
								<p style="font-size:200%; font-weight:bold"><em>mov</em> stored data example</p>
								<table>
									<tr>
										<td><img src="../../assets/mov_pointer2.png"> </td>
										<td><img src="../../assets/dereference2.png"></td>
									</tr>
								</table>
							</section>

							<section>
								<h2>Load Effective Address</h2>
								<img src="../../assets/lea_example1.png">

								<aside class="notes">
									; calculate the address by taking the address of what rdx points at, /
									; and adding 8 bytes to it (perhaps indexing into an array?)
									; NOTE: We are just calculating the addressees, not changing them!
									; this will access whatever was in rdx + 8
								</aside>

							</section>

							<section>
								<h2>xchg</h2>
								<img src="../../assets/xchg_example1.png">
								<p style="font-size: 80%; font-weight:bold">You cannot directly swap /xchg 2
									dereferenced
									pointers</p>
								<p style="font-size: 80%">See also <a
										href="https://stackoverflow.com/questions/43562980/swapping-two-int-pointers-in-assembly-x86">here</a>
								</p>

								<aside class="notes">
									; exchange two register values
									; exchange a register value with a value stored in memory
								</aside>


							</section>

							<section>
								<h2>xchg</h2>
								<img src="../../assets/xchg_example2.png">

								<aside class="notes">
									xchg rax, rcx ; what is the value or rax and rcx now?
									mov rcx, 0xdeadbeef ; setting rcx to an address
									mov [rcx], 0
									xchg rax, [rcx] ; what is the value of rax and rcx now?
								</aside>


							</section>



							<section>
								<h2>Debugging ASM</h2>
								<h3>using cmake</h3>
								<h3>using GDB</h3>
							</section>

							<section>
								<h2>Using cmake with Lab 1 </h2>
								<div style="background-color: black; color: #00ff00; ">
									<br>

									<p>cd /path/to/labs/Lab_1/</p>
									<p>ls -rt</p>
									<p>sudo apt install cmake</p>
									<p>cmake . && cmake --build .</p>
									<br>
								</div>
								<p><em>Notice the '.' </em></p>
							</section>

							<section>
								<h2>Debugging with cmake</h2>
								<h3>Now </h3>
								<div style="background-color: black; color: #00ff00; font-size:220%; font-weight:bold">

									ls -rt

								</div>
								<p>There should be new files</p>
							</section>

							<section>
								<h2>GDB debugging</h2>
								<ul>
									<li>gdb lab1</li>
									<li>tui enable</li>
									<li>break first_func</li>
									<li>run</li>
								</ul>
							</section>
							<section>
								<h2>GDB debugging </h2>
								<table>
									<tr>
										<td></td>
										<td><img src="../../assets/gdb_example0.png" height="150"></td>
									</tr>
									<tr>
										<td></td>
										<td><img src="../../assets/gdb_example1.png" height="150"></td>
									</tr>
								</table>


							</section>
							<section>
								<h2>GDB debugging</h2>
								<img src="../../assets/gdb_example2.png" height="550">
							</section>

							<section>
								<p style="font-size:120%; font-weight:bold">Many registers for you to view... </p>
								<p style="font-size:120%; font-weight:bold">info registers</p>
								<td><img src="../../assets/gdb_registers1.png" height="400" alt="Registers in GDB">


							</section>





							<section>
								<p style="font-size:120%; font-weight:bold">Many registers for you to view... </p>
								<p style="font-size:120%; font-weight:bold">info registers r/e/a tab </p>
								<td><img height="400" src="../../assets/gdb_registers2.png" alt="Registers in GDB">

							</section>

							<section>
								<h2>GDB debugging</h2>
								<p>s <em style="color:#f82571;">steps</em> to the next line</p>
								<p>n goes to the <em style="color:#a6e22e;">next instruction</em></p>
								<p>continue</p>
								<p>finish</p>
								<p style="font-size: 80%;">For more information see <a
										href="https://unix.stackexchange.com/questions/297982/how-to-step-into-step-over-and-step-out-with-gdb">here</a>
								</p>
							</section>

							<section>
								<h2>Complete Lab 1</h2>
								<p style="font-size:120%; font-weight:bold">Using the 'Lab_1' folder in <em>labs</em>
								</p>
								<img src="../../assets/success_lab1.png" alt="Successful Lab 1">
							</section>

				</section>

				<section data-background-image=" images/org_symbol.png" data-background-size="13%"
					data-background-position="top 5% left 5%">
					<section>
						<h2>ASM Basic Data Types </h2>
						<h3>and Memory</h3>

					</section>

					<section>
						<h2>Assembly Data Sizes</h2>
						<table>
							<tr>
								<td><em>Unit</em></td>
								<td><em>Description</em></td>
							</tr>
							<tr>
								<td>Byte</td>
								<td>Smallest addressable unit - 8 bits</td>
							</tr>
							<tr>
								<td>Word</td>
								<td>2 bytes</td>
							</tr>
							<tr>
								<td>D word</td>
								<td>double word (4 bytes - x86 pointer width)</td>
							</tr>
							<tr>
								<td>Q word</td>
								<td>quad word (8 bytes - x64 pointer width)</td>
							</tr>

						</table>

					</section>

					<section>
						<h4>General Purpose</h4>
						<h4>Registers and Sub-registers</h4>
						<table style="border: 1px solid black;">
							<tr>
								<td><em>64 Bit</em></td>
								<td><em>32 Bit</em></td>
								<td><em>16 Bit</em></td>
								<td><em>8 Bit</em> high/low</td>
							</tr>

							<tr>
								<td>rax</td>
								<td>eax</td>
								<td>ax</td>
								<td>ah/al</td>
							</tr>
							<tr>
								<td>rbx</td>
								<td>ebx</td>
								<td>bx</td>
								<td>bh/bl</td>
							</tr>

							<tr>
								<td>rcx</td>
								<td>ecx</td>
								<td>cx</td>
								<td>ch/cl</td>
							</tr>
							<tr>
								<td>rdx</td>
								<td>edx</td>
								<td>dx</td>
								<td>dh/dl</td>
							</tr>
							<tr>
								<td>rdi</td>
								<td>edi</td>
								<td>N/A</td>
								<td>N/A</td>
							</tr>
							<tr>
								<td>rsi</td>
								<td>esi</td>
								<td>N/A</td>
								<td>N/A</td>
							</tr>
						</table>

					</section>
					<section>
						<h2>Specify the amount of data copied</h2>
						<div class="sl-block" data-block-type="code">
							<div class="sl-block-content notranslate" data-highlight-theme="monokai"
								data-code-frame="none" style="z-index: 10;">
								<pre style="font-size: 36px; line-height: 42px;"><code>
mov al, byte [rsi]   
; copy a single byte
mov eax, dword [rcx] 
; copy a dword (4 bytes)
mov rax, qword [rsi]
; copy a qword (8 bytes)
						</code></pre>
							</div>
						</div>
					</section>
					<section>
						<h2>What if the source register is smaller than the destination register?</h2>
						<h3>What if you don't do anything?</h3>
					</section>
					<section>
						<p style="color:#c577dc;  font-size:220%; font-weight:bold"><em>movzx</em></p>
						<div class="sl-block" data-block-type="code">
							<div class="sl-block-content notranslate" data-highlight-theme="monokai"
								data-code-frame="none" style="z-index: 10;">
								<pre style="font-size: 36px; line-height: 42px;"><code>
movzx rax, cl                   
; everything above al is now set to 0
movzx rax, byte [rsi + 5]       
; what happens here?
						</code></pre>
							</div>
						</div>
					</section>
					<section>
						<h2>Complete Lab 2</h2>
						<p style="font-size:120%; font-weight:bold">Using the 'Lab_2' folder in <em>labs</em>
						</p>
						<img src="../../assets/success_lab2.png" alt="Successful Lab 2">
					</section>

				</section>

				<section data-background-image=" images/org_symbol.png" data-background-size="13%"
							data-background-position="top 5% left 5%">
					<section>
						<h2>ASM Advanced Data Types</h2>
						<h3><em>Structures</em></h3>
						<h3>Array Iteration</h3>
					</section>
					<section>
						<h2>Structures</h2>
						<div class="sl-block" data-block-type="code">
							<div class="sl-block-content notranslate" data-highlight-theme="monokai"
								data-code-frame="none" style="z-index: 10;">
								<pre style="font-size: 36px; line-height: 42px;"><code>
struc MyStruct
	.field1         resd 1      
	.field2         resd 1      
	.field3         resq 1     
	.next           resd 1      
endstruc
		</code></pre>
							</div>
						</div>
						<p style="font-size: 80%; font-weight:bold">This <em>struc</em> is not the same as
							<em>struct</em>
							inC </p>
						<p style="font-size: 70%;"><i>dword = 4bytes; qword = 8 bytes</i></p>
						<aside class="notes">
							; field1's size is 1 dword
							; field2's size is 1 dword
							; field3's size is 1 qword
							; next's size is 1 dword... address to next node in linked-list (if this were a
							linked list)
						</aside>
					</section>

					<section>
						<h3>rdi points to MyStruct</h3>
						<h3>This is equivalent to: <br>mov rax, [rdi+8]</h3>
						<div class="sl-block" data-block-type="code">
							<div class="sl-block-content notranslate" data-highlight-theme="monokai"
								data-code-frame="none" style="z-index: 10;">
								<pre style="font-size: 36px; line-height: 42px;"><code>
mov rax, [rdi + MyStruct.field3]
		</code></pre>
							</div>
						</div>
					</section>
					<section>
						<h3>Similarly -</h3>
						<h4> a linked list</h4>

						<div class="sl-block" data-block-type="code">
							<div class="sl-block-content notranslate" data-highlight-theme="monokai"
								data-code-frame="none" style="z-index: 10;">
								<pre style="font-size: 36px; line-height: 42px;"><code>
mov rdi, [rdi + MyStruct.next]
</code></pre>
							</div>
						</div>
						<h4>After the instruction completes, rdi points to the next node</h4>

					</section>

					<section>
						<h2>Array Iteration in Assembly</h2>
						<img src="../../assets/assembly_array_rev.png" alt="Illustration of Array in Assembly">
						<p style="font-size: 80%;">Original image and more information <a
								href="https://www.geeksforgeeks.org/assembly-language-program-find-largest-number-array/">here</a>
						<aside class="notes">

						</aside>
					</section>

					<section>
						<h2>Array Iteration Steps</h2>
						<h3>Dereference</h3>
						<h3>add the number of bytes to next element</h3>
					</section>

					<section>
						<p>Given that - <br>rsi has the address to an array of characters</p>
						<div class="sl-block" data-block-type="code">
							<div class="sl-block-content notranslate" data-highlight-theme="monokai"
								data-code-frame="none" style="z-index: 10;">
								<pre style="font-size: 36px; line-height: 42px;"><code>
mov rax, [rsi]      
; copies the first character
mov rax, [rsi+1]    
; copies the second character
mov rax, [rsi+5]    
; copies the sixth character
mov rax, [rsi]      
; still copies the first character

</code></pre>
							</div>
						</div>
					</section>


					<section>
						<p style="font-size:120%; font-weight:bold">Manual <em>leap frog</em> iteration</p>
						<h4>ints are 4 bytes so:</h4>
						<div class="sl-block" data-block-type="code">
							<div class="sl-block-content notranslate" data-highlight-theme="monokai"
								data-code-frame="none" style="z-index: 10;">
								<pre style="font-size: 36px; line-height: 42px;"><code>
add rsi, 4          
; next iteration
mov rax, [rsi]      
; next value
add rsi, 4
mov rax, [rsi]      
; third value
</code></pre>
							</div>
						</div>
						<p>This is moving the location of the pointer down 4 bytes</p>

					</section>
					<section>
						<h2><em>Explain to a partner</em> - <br>2 or more ways to iterate through an array in
							Assembly
						</h2>

					</section>
				</section>
					<section data-background-image="images/org_symbol.png" data-background-size="13%"
						data-background-position="top 5% left 5%">
						<h2>Conclusion</h2>
						<ul>
							<li>What is ASM?</li>
							<li>Why would we use ASM?</li>
							<li>What are the ASM basic operands?</li>
							<li>What are the ASM basic data types?</li>
							<li>What are ASM advanced data types?</li>
							<li>How can we move through arrays in Assembly?</li>
						</ul>
					</section>
					<section>
						<h3>Reflection</h3>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="13%"
						data-background-position="top 5% left 5%">
						<h2>Questions?</h2>
					</section>
		</div>
	</div>
	<!-- This footer doesn't work. Need to play with CSS -->
	<!-- <footer style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer> -->

	<!-- DO NOT TOUCH -->
	<script src="js/reveal.js"></script>

	<script>
		Reveal.initialize({
			slideNumber: true,
			hash: true,
			menu: {
				side: 'left',
				width: 'normal',
				numbers: true,
				titleSelector: 'h1, h2, h3, h4, h5, h6',
				useTextContentForMissingTitles: false,
				hideMissingTitles: false,
				markers: true,
				custom: false,
				themes: true,
				themesPath: 'css/theme/',
				transitions: true,
				openButton: true,
				openSlideNumber: true,
				keyboard: true,
				sticky: true,
				autoOpen: true,
				delayInit: false,
				openOnInit: false,
				loadIcons: true
			},
			dependencies: [
				{ src: 'plugin/markdown/marked.js' },
				{ src: 'plugin/markdown/markdown.js' },
				{ src: 'plugin/highlight/highlight.js' },
				{ src: 'plugin/notes/notes.js', async: true },
				{ src: 'plugin/reveal.js-menu/menu.js' }
			]
		});
		Reveal.configure({ slideNumber: true })
	</script>
</body>

</html>